'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _sourceMapSupport2 = require('source-map-support');

var _wdioLogger = require('wdio-logger');

var _wdioLogger2 = _interopRequireDefault(_wdioLogger);

var _wdioConfig = require('wdio-config');

var _monad = require('./monad');

var _monad2 = _interopRequireDefault(_monad);

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _constants = require('./constants');

var _utils = require('./utils');

var _webdriver = require('../protocol/webdriver.json');

var _webdriver2 = _interopRequireDefault(_webdriver);

var _jsonwp = require('../protocol/jsonwp.json');

var _jsonwp2 = _interopRequireDefault(_jsonwp);

var _mjsonwp = require('../protocol/mjsonwp.json');

var _mjsonwp2 = _interopRequireDefault(_mjsonwp);

var _appium = require('../protocol/appium.json');

var _appium2 = _interopRequireDefault(_appium);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

(0, _sourceMapSupport2.install)();
class WebDriver {
    static newSession(options = {}, modifier, proto = {}, commandWrapper) {
        return _asyncToGenerator(function* () {
            const params = (0, _wdioConfig.validateConfig)(_constants.DEFAULTS, options);
            _wdioLogger2.default.setLevel('webdriver', params.logLevel);

            const sessionRequest = new _request2.default('POST', '/session', {
                capabilities: params.capabilities, // W3C compliant
                desiredCapabilities: params.capabilities // JSONWP compliant
            });

            const response = yield sessionRequest.makeRequest(params);
            params.capabilities = response.value.capabilities || response.value;
            params.isW3C = Boolean(response.value.capabilities);

            const prototype = Object.assign(WebDriver.getPrototype(params.isW3C), proto);
            const monad = (0, _monad2.default)(params, modifier, prototype);
            return monad(response.value.sessionId || response.sessionId, commandWrapper);
        })();
    }

    static get WebDriver() {
        return WebDriver;
    }
    static get DEFAULTS() {
        return _constants.DEFAULTS;
    }
    static get WebDriverProtocol() {
        return _webdriver2.default;
    }
    static get JsonWProtocol() {
        return _jsonwp2.default;
    }
    static get MJsonWProtocol() {
        return _mjsonwp2.default;
    }
    static get AppiumProtocol() {
        return _appium2.default;
    }
    static get webdriverMonad() {
        return _monad2.default;
    }
    static get getPrototype() {
        return _utils.getPrototype;
    }
}
exports.default = WebDriver;
module.exports = exports['default'];